'From Cuis 5.0 [latest update: #4256] on 11 July 2020 at 2:48:35 pm'!
!classDefinition: #MorphicCanvas category: #'Morphic-Support'!
Object subclass: #MorphicCanvas
	instanceVariableNames: 'form clipRect transformations currentTransformation cti currentMorph drawingMorphStack engine world '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Support'!

!Morph methodsFor: 'geometry' stamp: 'jmv 7/10/2020 15:52:58'!
lastBoundsInWorld
	self visible ifFalse: [ ^nil ].
	^ self valueOfProperty: #lastBoundsInWorld! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/10/2020 15:53:02'!
lastBoundsInWorld: aRectangle
	self setProperty: #lastBoundsInWorld toValue: aRectangle! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/10/2020 15:53:40'!
lastFullBoundsInWorld
	"Answer a rectangle that completely bounds receiver and submorphs when drawn 
		(if the world was to be fully drawn, i.e. only to be used on a Canvas on the full world).
	Might be larger than strictly required."

	| answer |
	answer _ self lastBoundsInWorld.
	answer isNil ifTrue: [ ^nil ].
	self submorphsDrawingOutsideReverseDo: [ :m |
		m lastFullBoundsInWorld ifNotNil: [ :r |
			answer _ answer merge: r ]].
	^answer! !

!Morph methodsFor: 'geometry testing' stamp: 'jmv 7/11/2020 09:53:46'!
requiresVectorCanvas
	"Answer true if we can not be drawn by BitBltCanvas, because we use VectorCanvas protocol (i.e. Vector Graphics) or because our location includes rotation or scaling."
	^true! !


!RectangleLikeMorph methodsFor: 'geometry testing' stamp: 'jmv 7/11/2020 09:54:07'!
requiresVectorCanvas
	"Answer true if we can not be drawn by BitBltCanvas, because we use VectorCanvas protocol (i.e. Vector Graphics) or because our location includes rotation or scaling."
	^location isPureTranslation not! !


!PasteUpMorph methodsFor: 'geometry' stamp: 'jmv 7/10/2020 15:52:04'!
lastBoundsInWorld
	^self isWorldMorph ifTrue: [0@0 extent: extent] ifFalse: [super lastBoundsInWorld]! !


!MorphicCanvas methodsFor: 'initialization' stamp: 'jmv 7/11/2020 00:01:48'!
world: aPasteUpMorph
	world _ aPasteUpMorph.
	self into: world! !


!WorldState methodsFor: 'canvas' stamp: 'jmv 7/11/2020 00:01:55'!
setCanvas: aMorphicCanvas
	canvas _ aMorphicCanvas.
	canvas world: world.
	damageRecorder
		ifNil: [ damageRecorder _ DamageRecorder new].
	damageRecorder doFullRepaint! !


!MorphicCanvas methodsFor: 'morphic' stamp: 'jmv 7/11/2020 11:35:53'!
drawCurrentAndSubmorphs

	self isCurrentMorphVisible ifTrue: [
		currentMorph drawOn: self.
		world notNil ifTrue: [
			currentMorph lastBoundsInWorld: self boundingRectOfCurrentMorphAfterDraw ].
		"Display submorphs back to front"
		"coordinate system stack already set up for aMorph
		('ivars transformations' and 'currentTransformation')"
		currentMorph hasSubmorphs ifTrue: [
			currentMorph clippedSubmorph ifNotNil: [ :clipped |
				self clippingByCurrentMorphDo: [ self fullDraw: clipped ]].
			currentMorph unclippedSubmorphsReverseDo: [ :m |
				self fullDraw: m ]]].! !

!MorphicCanvas methodsFor: 'private' stamp: 'jmv 7/11/2020 09:41:46'!
boundingRectOfCurrentMorphAfterDraw
	"This rectangle is used for clipping submorphs in BitBltCanvas.
	In VectorCanvas we support clipping by any shape, not just rectangles. Then, this rectangle is used as an optimization of the area to be redrawn."

	self subclassResponsibility! !


!BitBltCanvas methodsFor: 'private' stamp: 'jmv 7/11/2020 09:40:53'!
boundingRectOfCurrentMorph
	"In targetForm coordinates
	BitBltCanvas is only used on unrotated RectangleLikeMorphs"

	^currentTransformation displayBoundsOfTransformOf: currentMorph morphLocalBounds! !

!BitBltCanvas methodsFor: 'private' stamp: 'jmv 7/11/2020 09:39:43'!
boundingRectOfCurrentMorphAfterDraw
	"In targetForm coordinates"

	^ self boundingRectOfCurrentMorph! !

!classDefinition: #MorphicCanvas category: #'Morphic-Support'!
Object subclass: #MorphicCanvas
	instanceVariableNames: 'world form clipRect transformations currentTransformation cti currentMorph drawingMorphStack engine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Support'!

!MorphicCanvas reorganize!
('accessing' clipRect currentTransformation depth extent form newClipRect:)
('drawing' line:to:width:color:)
('drawing-icons' drawButtonIconFromCurrentMorph)
('drawing-images' image:at: image:at:sourceRect: image:multipliedBy:at: stencil:at:color: stencil:at:sourceRect:color:)
('drawing-ovals' ellipseCenterX:y:rx:ry:borderWidth:borderColor:fillColor:)
('drawing-rectangles' fillRectangle:color: fillRectangle:color:borderWidth:borderStyleSymbol:baseColorForBorder: fillRectangle:tilingWith:multipliedBy: frameAndFillRectangle:fillColor:borderWidth:borderColor: frameRectangle:borderWidth:color: frameRectangle:color:borderWidth:borderStyleSymbol: reverseRectangleBorder:borderWidth:)
('drawing-roundedRectangles' roundRect:color:radius: roundRect:color:radius:gradientTop:gradientBottom:gradientHeight: roundRect:color:radius:gradientTop:gradientCenter:gradientBottom:gradient1Height: windowFrame:color:radius:border:labelHeight:gradientTop:gradientBottom:insideColor:)
('drawing-text' drawString:at:font:color: drawString:at:font:color:embossed: drawString:from:to:at:font:color: drawStringEmbossed:from:to:at:font:color: textComposition:bounds:color:selectionColor:)
('initialization' initializeWith:origin: world:)
('morphic' clippingMorph: displayBoundsInWorldOf: displayFullBoundsInWorldOf: drawCurrentAndSubmorphs drawCurrentAsError drawCurrentAsOutline fullDraw: fullDrawHand: into: outOfMorph)
('other' contentsOfArea:into: showAt:invalidRects:)
('printing' printOn:)
('testing' drawsOnDisplay isCurrentMorphVisible)
('private' boundingRectOfCurrentMorphAfterDraw canvasOrigin canvasToUse clippingByCurrentMorphDo: externalizeDisplayBounds:from: setClipRect: setForm:)
!


!BitBltCanvas reorganize!
('drawing' line:to:width:color:)
('drawing-icons' drawButtonIconFromCurrentMorph)
('drawing-images' image:at: image:at:sourceRect: image:multipliedBy:at: stencil:at:color: stencil:at:sourceRect:color:)
('drawing-ovals' ellipseCenterX:y:rx:ry:borderWidth:borderColor:fillColor:)
('drawing-rectangles' fillRectangle:color: fillRectangle:color:borderWidth:borderStyleSymbol:baseColorForBorder: fillRectangle:tilingWith:multipliedBy: frameAndFillRectangle:fillColor:borderWidth:borderColor: frameRectangle:borderWidth:color: frameRectangle:color:borderWidth:borderStyleSymbol: reverseRectangleBorder:borderWidth:)
('drawing-roundedRectangles' roundRect:color:radius: roundRect:color:radius:gradientTop:gradientBottom:gradientHeight: roundRect:color:radius:gradientTop:gradientCenter:gradientBottom:gradient1Height: windowFrame:color:radius:border:labelHeight:gradientTop:gradientBottom:insideColor:)
('drawing-text' drawString:from:to:at:font:color: drawStringEmbossed:from:to:at:font:color:)
('initialization' initializeWith:origin:)
('private' boundingRectOfCurrentMorph boundingRectOfCurrentMorphAfterDraw buildAuxWith:multipliedWith: fillRectangle:tilingWith:sourceRect:rule: frameRectangle:borderWidth:topLeftColor:bottomRightColor: resetEngine setClipRect: setForm: setPaintColor:)
('morphic')
('testing' isCurrentMorphVisible)
!

