'From Cuis 5.0 [latest update: #4257] on 11 July 2020 at 8:55:29 pm'!

!Morph methodsFor: 'geometry' stamp: 'jmv 7/11/2020 17:25:00'!
lastBoundsInWorldOrBogus
	"Never answer nil. A bogus value will trigger a draw operation, and bounds will then be corrected."
	^self lastBoundsInWorld ifNil: [
		Rectangle center: (self externalizeToWorld: 0@0) extent: 2@2 ]! !


!RectangleLikeMorph methodsFor: 'geometry' stamp: 'jmv 7/11/2020 17:43:23'!
morphBoundsInWorld

	"usar esto o el heredado?
	borrar displayBoundsInWorldOf:"

	self visible ifFalse: [ ^nil ].
	^self world ifNotNil: [ :w | w canvas ifNotNil: [ :c | c displayBoundsInWorldOf: self ]]! !

!RectangleLikeMorph methodsFor: 'geometry' stamp: 'jmv 7/11/2020 17:46:30'!
morphFullBoundsInWorld

	"usar esto o el heredado?
	borrar displayFullBoundsInWorldOf:"

	self flag: #jmvVer2.
	self visible ifFalse: [ ^nil ].
	^self world ifNotNil: [ :w | w canvas displayFullBoundsInWorldOf: self ]! !


!Morph methodsFor: 'geometry' stamp: 'jmv 7/11/2020 17:32:19'!
lastBoundsInWorld: aRectangle
	"If we update know bounds, chances are last draw operation used incorrect value. Draw again then."

	self lastBoundsInWorld ~= aRectangle ifTrue: [
		self setProperty: #lastBoundsInWorld toValue: aRectangle.
		self redrawNeeded ]! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/11/2020 17:36:12'!
morphBoundsInWorld

	"Si alcanza con esto... para que quiero el otro?"

	^self lastBoundsInWorld! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/11/2020 17:47:00'!
morphFullBoundsInWorld

	"Si alcanza con esto... para que quiero el otro?"

	^self lastFullBoundsInWorld! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/11/2020 17:55:56'!
worldBoundsForHalo
	"Answer the rectangle to be used as the inner dimension of my halos.
	Allow for showing either bounds or fullBounds, and compensate for the optional bounds rectangle."

	^ Preferences haloEnclosesFullBounds
		ifFalse: [ self lastBoundsInWorld ]
		ifTrue: [ self lastFullBoundsInWorld ]! !

!Morph methodsFor: 'updating' stamp: 'jmv 7/11/2020 17:26:16'!
redrawNeeded
	"Report that the area occupied by this morph should be redrawn.
	Note that we might not know what area we occupy. #lastBoundsInWorldOrBogus could be outdated or bogus.
	Even then, an imperfect draw operation will update our #lastBoundsInWorld:, and a new #redrawNeeded will be later done."

	self invalidateDisplayRect: self lastBoundsInWorldOrBogus from: nil.
	"Expensive in many cases..."
	self submorphsDrawingOutsideReverseDo: [ :m | m redrawNeeded ]! !


!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'jmv 7/11/2020 17:58:03'!
acceptDroppingMorph: aMorph event: evt 
	"The supplied morph, known to be acceptable to the receiver, is now to be assimilated; the precipitating event is supplied"

	self isWorldMorph 
		ifTrue: [	
			"Add the given morph to this world and start stepping it if it wants to be."
			self addMorphFront: aMorph.
			(aMorph lastFullBoundsInWorld intersects: self viewBox) 
				ifFalse: [
					Smalltalk beep.
					aMorph morphPosition: extent // 2]]
		ifFalse: [super acceptDroppingMorph: aMorph event: evt].
	aMorph submorphsDo: [ :m | (m is: #HaloMorph) ifTrue: [ m delete ]]! !


!WorldState methodsFor: 'drawing' stamp: 'jmv 7/11/2020 18:37:04'!
drawInvalidAreasSubmorphs: submorphs
	"Redraw the damaged areas of the given canvas and clear the damage list. Return a collection of the areas that were redrawn."

	| initialRectsToRepair currentRectsToRepair newRectsToRepair morphsToDraw rectsForEachMorph thisMorphRects reuse i n morph morphBounds morphClipRect |

	"The simple implementation is slowers as it draws morph areas that will later be covered by other morphs.
	But it works, and it is easier to understand.
	See en.wikipedia.org/wiki/Painter's_algorithm"
	true not ifTrue: [ ^self simpleDrawInvalidAreasSubmorphs: submorphs ].

	"The response for #invalidRectsFullBounds: can include nils, that should be ignored."
	initialRectsToRepair _ damageRecorder invalidRectsFullBounds: world viewBox.
	currentRectsToRepair _ OrderedCollection new.
	newRectsToRepair _ OrderedCollection withAll: initialRectsToRepair.
	morphsToDraw _ OrderedCollection new.
	rectsForEachMorph _ OrderedCollection new.
	thisMorphRects _ OrderedCollection new.
	n _ submorphs size.
	i _ 1.

	"The idea here is to iterate morphs front to back, i.e. first the ones on top.
	For each morph, record the rectangles it affects. And if a morph is opaque, remove the area behind it from the list of rectangles to be repaired.
	This means, for example, that morphs completely covered might even not be redrawn.
	this is a huge performance gain when there are many morphs on screen, especially if there are more than ten open windows, and Theme uses opaque colors.
	See 'A reverse painter's algorithm' at en.wikipedia.org/wiki/Painter's_algorithm"
	[ i <= n and: [ newRectsToRepair notEmpty ]] whileTrue: [
		morph _ submorphs at: i.
		morph visible ifTrue: [
			morphBounds _ morph morphFullBoundsInWorld ifNil: [ world viewBox ].
			reuse _ currentRectsToRepair.
			currentRectsToRepair _ newRectsToRepair.
			newRectsToRepair _ reuse removeAll.
			currentRectsToRepair do: [ :r |
				(morphBounds intersects: r)
					ifTrue: [
						morphClipRect _ morphBounds intersect: r.
						thisMorphRects add: morphClipRect. "We could perhaps try and join adjacent rectangles in this collection..."
						morph addPossiblyUncoveredAreasIn: r to: newRectsToRepair ]
					ifFalse: [
						newRectsToRepair add: r ]].
			thisMorphRects ifNotEmpty: [
				morphsToDraw add: morph.
				rectsForEachMorph add: thisMorphRects.
				thisMorphRects _ OrderedCollection new.
			]].
		i _ i + 1 ].

	"*make this true to flash damaged areas for testing*"
	Preferences debugShowDamage ifTrue: [ world fillRects: initialRectsToRepair ].

	"Draw world background on those areas that were not completely covered by opaque morphs"
	i > n  ifTrue: [
		newRectsToRepair do: [ :r |
			world drawOn: (canvas newClipRect: r) ]].

	"Now, draw the recorded areas of selected morphs, back to front."
	morphsToDraw with: rectsForEachMorph reverseDo: [ :m :xrects |
		"Here we could think about merging all xrects into just one call...
		This would mean drawing each morph just once.
		But that would mean drawing pixels we were not told to. There could be other morphs in that area that are not even being drawn!!
		See WorldState class >> #experiment1"
		"*make this true to flash damaged areas for testing*"
		Preferences debugShowDamage2 ifTrue: [
			world fillRects: xrects ].
"		rr _ nil."
		xrects do: [ :r |
"			rr _ rr ifNil: [ r ] ifNotNil: [ r quickMerge: rr ]."
			(canvas newClipRect: r) fullDraw: m.
		].
"		(canvas newClipRect: rr) fullDraw: m"
	].

	"Answer a list of rectangles to be updated on the Display.
	This usually is not performance critical, drawing morphs is slower than just exposing the Display."
	"What should we force on Display? Whatever was asked? Each small rect that was updated? A single bigger rect?
	Right now, answer whatever was asked... Maybe this could be changed if that enhances performance...
	(think of vnc over slow networks)"
	^ initialRectsToRepair! !

!WorldState methodsFor: 'drawing' stamp: 'jmv 7/11/2020 18:37:29'!
simpleDrawInvalidAreasSubmorphs: submorphs

	"mover todo esto al canvas, no?
	Y ver que hacer con los argumentos, etc.... Toda esta bananarama!!"

	"Redraw the damaged areas of the given canvas and clear the damage list.
	Return a collection of the areas that were redrawn.
	This simple implementation just does as requested: No optimizations are done."

	| rectsToRepair morphBounds |
	"The response for #invalidRectsFullBounds: can include nils, that should be ignored."
	rectsToRepair _ damageRecorder invalidRectsFullBounds: world viewBox.

	"Draw World"
	rectsToRepair do: [ :r |
		world drawOn: (canvas newClipRect: r) ].

	"Draw morphs"
	submorphs reverseDo: [ :morph |
		morph visible ifTrue: [
			morphBounds _ morph morphFullBoundsInWorld ifNil: [ world viewBox ].
			rectsToRepair do: [ :r |
				(morphBounds intersects: r) ifTrue: [
					(canvas newClipRect: r) fullDraw: morph ]]]].

	^ rectsToRepair! !

!methodRemoval: RectangleLikeMorph #lastBoundsInWorld: stamp: 'jmv 7/11/2020 20:55:07'!
RectangleLikeMorph removeSelector: #lastBoundsInWorld:!
