'From Cuis 5.0 [latest update: #4263] on 12 July 2020 at 4:07:10 pm'!

!Morph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 16:00:17'!
lastBoundsInWorld
	"At time of last draw. nil if unknown."

	self visible ifFalse: [ ^nil ].
	^ self valueOfProperty: #lastBoundsInWorld! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 15:56:07'!
lastFullBoundsInWorld
	"Answer a rectangle that completely bounds receiver and submorphs when last drawn 
		(if the world was to be fully drawn, i.e. only to be used on a Canvas on the full world).
	Might be larger than strictly required."

	| answer |
	answer _ self lastBoundsInWorld.
	answer isNil ifTrue: [ ^nil ].
	self submorphsDrawingOutsideReverseDo: [ :m |
		m lastFullBoundsInWorld ifNotNil: [ :r |
			answer _ answer merge: r ]].
	^answer! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 16:06:17'!
morphBoundsInWorld
	"Answer a rectangle that completely bounds receiver.
	Might be larger than strictly required."
	"Maybe nil if unknown. Maybe outdated. If so, we'll eventually be redrawn and corrected.
	Senders need to be aware of this.
	Subclasses with better knowledge may redefine this method."
	"Many senders could be made to call #lastBoundsInWorld instead."

	^self lastBoundsInWorld! !

!Morph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 16:02:50'!
morphFullBoundsInWorld
	"Answer a rectangle that completely bounds receiver and submorphs.
	Might be larger than strictly required."
	"Maybe nil if unknown. Maybe outdated. If so, we'll eventually be redrawn and corrected.
	Senders need to be aware of this.
	Subclasses with better knowledge may redefine this method."

	^self lastFullBoundsInWorld! !


!RectangleLikeMorph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 16:02:36'!
morphBoundsInWorld
	"Answer a rectangle that completely bounds receiver.
	Might be larger than strictly required."

	self visible ifFalse: [ ^nil ].
	^self world ifNotNil: [ :w | w canvas ifNotNil: [ :c |
			c externalizeDisplayBounds: self morphLocalBounds from: self ]]! !

!RectangleLikeMorph methodsFor: 'geometry' stamp: 'jmv 7/12/2020 16:02:40'!
morphFullBoundsInWorld
	"Answer a rectangle that completely bounds receiver and submorphs.
	Might be larger than strictly required."

	| answer |
	answer _ self morphBoundsInWorld.
	answer isNil ifTrue: [ ^nil ].
	self submorphsDrawingOutsideReverseDo: [ :m |
		m morphFullBoundsInWorld ifNotNil: [ :r |
			answer _ answer merge: r ]].
	^answer! !

!methodRemoval: MorphicCanvas #displayBoundsInWorldOf: stamp: 'jmv 7/12/2020 15:57:40'!
MorphicCanvas removeSelector: #displayBoundsInWorldOf:!
!methodRemoval: MorphicCanvas #displayFullBoundsInWorldOf: stamp: 'jmv 7/12/2020 15:56:28'!
MorphicCanvas removeSelector: #displayFullBoundsInWorldOf:!
!methodRemoval: PasteUpMorph #acceptDroppingMorph:event: stamp: 'jmv 7/12/2020 15:41:25'!
PasteUpMorph removeSelector: #acceptDroppingMorph:event:!
