'From Cuis 5.0 [latest update: #4264] on 13 July 2020 at 11:07:04 am'!

!HandMorph methodsFor: 'geometry' stamp: 'jmv 7/13/2020 11:06:49'!
submorphsFullBoundsInWorld
	"Current full bounds of submorphs carried by the hand.
	Submorphs might have never been drawn at this hand position (this is usually the case when dragging morphs around)."
	| fullBounds |
	submorphs isEmpty ifTrue: [ ^nil ].
	fullBounds _ nil.
	(self valueOfProperty:#lastPos)
		ifNil: [						"Just once when a new morph (not in the world) is attached to the hand."
			self submorphsDo: [ :m |
				m morphFullBoundsInWorld ifNotNil: [ :b |
					fullBounds _ fullBounds ifNil: [b] ifNotNil: [ fullBounds merge: b ]]]]
		ifNotNil: [ :lastPos |						"When carrying morphs around."
			self submorphsDo: [ :m |
				m lastFullBoundsInWorld ifNotNil: [ :b |
					fullBounds _ fullBounds ifNil: [b] ifNotNil: [ fullBounds merge: b ]]].
			fullBounds ifNil: [ ^nil ].						"bueeeenoooo"
			fullBounds _ fullBounds translatedBy: self morphPosition-lastPos ].
	^fullBounds! !


!HandMorph methodsFor: 'drawing' stamp: 'jmv 7/13/2020 09:50:36'!
fullDrawHandOn: aCanvas
	"A HandMorph has an unusual drawing requirement:
		The hand itself (i.e., the cursor) appears in front of its submorphs
	The illusion is that the hand plucks up morphs and carries them above the world."

	submorphs reverseDo: [ :m | aCanvas fullDraw: m ].
	self drawOn: aCanvas.  "draw the hand itself in front of morphs"
	self setProperty: #lastPos toValue: (submorphs notEmpty ifTrue: [self morphPosition] ifFalse: [nil])! !

!HandMorph methodsFor: 'grabbing/dropping' stamp: 'jmv 7/13/2020 10:31:49'!
grabMorph: aMorph delta: delta
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner)."

	| formerOwner |
	self releaseMouseFocus. "Break focus"

	"Grab the halo if present"
	self halo ifNotNil: [ :h |
		h target == aMorph ifTrue: [
			self addMorphBack: h position: h morphPositionInWorld - self morphPositionInWorld ]].

	"Remember previous owner and position, in case the drop is later rejected"
	formerOwner _ aMorph owner.
	formerOwner ifNotNil: [
		grabMorphData
			at: aMorph 
			put: { formerOwner. aMorph morphPositionInWorld. } ].
	self addMorphBack: aMorph position: delta.
	aMorph justGrabbedFrom: formerOwner.
	formerOwner ifNotNil: [
		self setProperty: #lastPos toValue: self morphPosition ].! !

!HandMorph methodsFor: 'geometry' stamp: 'jmv 7/13/2020 11:04:19'!
morphFullBoundsInWorld
	| fullBounds |
	fullBounds _ self morphBoundsInWorld.
	self submorphsFullBoundsInWorld ifNotNil: [ :b |
		fullBounds _ fullBounds merge: b ].
	^fullBounds! !


!HaloMorph methodsFor: 'event handling' stamp: 'jmv 7/12/2020 21:28:50'!
redrawNeeded
	"Report that the area occupied by this morph should be redrawn."

	self
		invalidateDisplayRect:
			((self morphBoundsInWorld
				outsetBy: self class handleSize*2)
					extendBy: 0@(FontFamily defaultLineSpacing+self class handleSize))
		from: nil.
	"Label could be wider than us..."
	self submorphsDrawingOutsideReverseDo: [ :m | m redrawNeeded ]! !

