'From Cuis 5.0 [latest update: #4266] on 13 July 2020 at 5:26:15 pm'!

!Morph methodsFor: 'geometry testing' stamp: 'jmv 7/13/2020 16:59:51'!
fullContainsGlobalPoint: worldPoint
"Answer true even if aLocalPoint is in some unclipped submorph, but outside us "

	"If not visible, won't contain any point at all."
	| canvas |
	self visible ifFalse: [ ^false ].

	canvas _ self world canvas.
	canvas isNil ifTrue: [ ^false ].
	(canvas morph: self isAtPoint: worldPoint) ifTrue: [ ^ true ]. 
	self submorphsDrawingOutsideReverseDo: [ :m |
		(m fullContainsGlobalPoint: worldPoint) ifTrue: [ ^ true ]].
	^ false! !


!RectangleLikeMorph methodsFor: 'geometry testing' stamp: 'jmv 7/13/2020 16:37:51'!
morphContainsPoint: aLocalPoint
"Answer true even if aLocalPoint is in asubmorph, as long as it is in our shape"

	"If not visible, won't contain any point at all."
	self visible ifFalse: [ ^false ].

	"Most morphs answer true to to #isOrthoRectangularMorph, or redefine this method..."
	self isOrthoRectangularMorph ifTrue: [
		^ self morphLocalBounds containsPoint: aLocalPoint ].
	
	"...But for those who not, provide correct albeit expensive behavior."
	"Can't do better. Please redefine in subclasses as appropriate!! (or finish Morphic 3!!)"
	"Mhhh. Podria usar el #imageForm: y ver si es transparente... deberia andar"
	^ self morphLocalBounds containsPoint: aLocalPoint! !


!MorphicCanvas methodsFor: 'private' stamp: 'jmv 7/13/2020 16:47:43'!
canvasToUseFor: aMorph

	^self.! !


!BitBltCanvas methodsFor: 'morphic' stamp: 'jmv 7/13/2020 16:43:16'!
morph: aMorph isAtPoint: aPoint

	^aMorph morphContainsPoint:
		(aMorph internalizeFromWorld: aPoint)! !


!Morph methodsFor: 'geometry testing' stamp: 'jmv 7/13/2020 17:00:03'!
fullContainsPoint: aLocalPoint
"Answer true even if aLocalPoint is in some unclipped submorph, but outside us "

	"If not visible, won't contain any point at all."
	self visible ifFalse: [ ^false ].

	^self fullContainsGlobalPoint: (self externalizeToWorld: aLocalPoint).! !


!HandMorph methodsFor: 'events-processing' stamp: 'jmv 7/13/2020 16:33:04'!
startMouseDispatch: aMouseEvent

	aMouseEvent isMouseOver ifTrue: [
		^self mouseFocus
			ifNotNil: [ mouseFocus handleFocusEvent: aMouseEvent ]
			ifNil: [ owner dispatchEvent: aMouseEvent localPosition: aMouseEvent eventPosition ]].

	"any mouse event but mouseOver"
	lastMouseEvent _ aMouseEvent.	
	lastMouseEventTime _ Time localMillisecondClock.

	"Check for pending drag or double click operations."
	mouseClickState ifNotNil: [
		(mouseClickState handleEvent: aMouseEvent from: self) ifTrue: [
			"Possibly dispatched #click: or something. Do not further process this event."
			^self mouseOverHandler processMouseOver: lastMouseEvent  ]].

	aMouseEvent isMove
		ifTrue: [
			self morphPosition: aMouseEvent eventPosition.
			self mouseFocus
				ifNotNil: [ mouseFocus handleFocusEvent: aMouseEvent ]
				ifNil: [ owner dispatchEvent: aMouseEvent localPosition: aMouseEvent eventPosition ]
		] ifFalse: [
			aMouseEvent isMouseScroll
				ifTrue: [
					owner dispatchEvent: aMouseEvent localPosition: aMouseEvent eventPosition] 
				ifFalse: [
					"Issue a synthetic move event if we're not at the position of the event"
					aMouseEvent eventPosition = self morphPosition ifFalse: [
						"Issue a mouse move event to make the receiver appear at the given position"
						self startMouseDispatch: (MouseMoveEvent new
							setType: #mouseMove
							position: aMouseEvent eventPosition
							buttons: aMouseEvent buttons
							hand: self
							stamp: aMouseEvent timeStamp) ].
					"Drop submorphs on button events"
					self hasSubmorphs
						ifTrue: [
							"Not if we are grabbing them"
							mouseClickState ifNil: [self dropMorphs: aMouseEvent ]]
						ifFalse: [
							self mouseFocus
								ifNotNil: [ mouseFocus handleFocusEvent: aMouseEvent ]
								ifNil: [ owner dispatchEvent: aMouseEvent localPosition: aMouseEvent eventPosition ]]]].
		self mouseOverHandler processMouseOver: self lastMouseEvent! !

!methodRemoval: Morph #morphContainsPoint: stamp: 'jmv 7/13/2020 17:09:37'!
Morph removeSelector: #morphContainsPoint:!
