'From Cuis 5.0 [latest update: #4267] on 14 July 2020 at 11:46:47 am'!

!HybridCanvas methodsFor: 'private' stamp: 'jmv 7/14/2020 11:43:49'!
newClipRect: aRectangleOrNil
	"This method is calledd when we are about to repair damaged rectangles.
	This is a good point to ensure that morphIds in our vectorCanvas is cleared of any previously drawn morph.
	This is not needed when using just a VectorCanvas. It is only needed in the HybridCanvas, where it might happen that those pixels will only contain only BitBltCanvas morphs."

	| auxBitBlt hack |
	self setClipRect: (aRectangleOrNil
		ifNil: [ `0@0` corner: form extent ]
		ifNotNil: [ aRectangleOrNil translatedBy: self canvasOrigin ]).

	aRectangleOrNil notNil ifTrue: [
		hack _ Form extent: form extent depth: 32 bits: (vectorCanvas engine instVarNamed: 'morphIds').
		auxBitBlt _ BitBlt toForm: hack.
		auxBitBlt fillBitmap: (Bitmap with: 16r00000000).
		auxBitBlt combinationRule: Form over.
		auxBitBlt destRect: aRectangleOrNil.
		auxBitBlt copyBits ]! !


!EllipseMorph2 methodsFor: 'as yet unclassified' stamp: 'jmv 7/14/2020 11:44:42'!
morphLocalBounds
"
Probablemente pueda sacarse de Morph y pasarlo a los DisplayRectMorph o como se llamen
"

"si. es por aca. Pero mas especificament #morphBoundsInWorld
displayBoundsInWorldOf:
En realidad, los dos.
""
"
	'--------------' print.
	thisContext printStack: 10.
""

^super morphLocalBounds

"
ver senders de
#puff
"! !


!VectorEngineSubPixel methodsFor: 'primitive algorithms - aux' stamp: 'jmv 7/14/2020 09:57:29'!
updateEdgeCountAtX: x y: y
	| thisYTruncated pixelY pixelIndexBase redPixelIndex greenPixelIndex bluePixelIndex increment countWord redCount greenCount blueCount redOffset greenOffset blueOffset |

	thisYTruncated _ y truncated .
	(thisYTruncated between: clipTop-1 and: clipBottom) ifFalse: [
		^ self ].
	prevYTruncated ifNil: [ 
		^ prevYTruncated _ thisYTruncated ].
	thisYTruncated = prevYTruncated ifTrue: [
		^ self].

	thisYTruncated > prevYTruncated
		ifTrue: [
			pixelY _ thisYTruncated.
			increment _ 1 ]
		ifFalse: [
			pixelY _ prevYTruncated.
			increment _ -1 ].
	prevYTruncated _ thisYTruncated.

	"All edge count at the left of the clipRect are added there (at the left of the clipRect).
	The effect is the same, and we need to clean up less stuff afterwards.
	More important, it avoids trying to acess pixels outside our form, i.e. invalid array acesses."
	pixelIndexBase _ pixelY * targetWidth.
	redOffset _ (x+subPixelDelta) truncated + 1 max: clipLeft.
	greenOffset _ x truncated + 1 max: clipLeft.
	blueOffset _ (x-subPixelDelta) truncated + 1 max: clipLeft.
	redPixelIndex _ pixelIndexBase + redOffset +1.
	greenPixelIndex _ pixelIndexBase + greenOffset +1.
	bluePixelIndex _ pixelIndexBase + blueOffset +1.

	"Three possible cases here: RGB in one word (pixel); RG in one, and G in another; R in one, GB in another"
	redPixelIndex = bluePixelIndex
		ifTrue: [						"First case: RGB in the same word"
			redOffset <= clipRight ifTrue: [
				countWord _ edgeCounts bytesAt: redPixelIndex.
				redCount _ (countWord at: 3) + increment bitAnd: 16rFF.
				countWord at: 3 put: redCount.
				greenCount _ (countWord at: 2) + increment bitAnd: 16rFF.
				countWord at: 2 put: greenCount.
				blueCount _ (countWord at: 1) + increment bitAnd: 16rFF.
				countWord at: 1 put: blueCount.
				edgeCounts bytesAt: redPixelIndex put: countWord ].
		]
		ifFalse: [
			redPixelIndex = greenPixelIndex
				ifTrue: [				"Second case: RG in one word, B in previous"
					redOffset <= clipRight ifTrue: [
						countWord _ edgeCounts bytesAt: redPixelIndex.
						redCount _ (countWord at: 3) + increment bitAnd: 16rFF.
						countWord at: 3 put: redCount.
						greenCount _ (countWord at: 2) + increment bitAnd: 16rFF.
						countWord at: 2 put: greenCount.
						edgeCounts bytesAt: redPixelIndex put: countWord ].

					blueOffset <= clipRight ifTrue: [
						countWord _ edgeCounts bytesAt: bluePixelIndex.
						blueCount _ (countWord at: 1) + increment bitAnd: 16rFF.
						countWord at: 1 put: blueCount.
						edgeCounts bytesAt: bluePixelIndex put: countWord ].
				]
				ifFalse: [			"Third case: R in one word, GB in the previous"
					redOffset <= clipRight ifTrue: [
						countWord _ edgeCounts bytesAt: redPixelIndex.
						redCount _ (countWord at: 3) + increment bitAnd: 16rFF.
						countWord at: 3 put: redCount.
						edgeCounts bytesAt: redPixelIndex put: countWord ].

					blueOffset <= clipRight ifTrue: [
						countWord _ edgeCounts bytesAt: bluePixelIndex.
						greenCount _ (countWord at: 2) + increment bitAnd: 16rFF.
						countWord at: 2 put: greenCount.
						blueCount _ (countWord at: 1) + increment bitAnd: 16rFF.
						countWord at: 1 put: blueCount.
						edgeCounts bytesAt: bluePixelIndex put: countWord ].
				]
		].! !


!VectorEngineWholePixel methodsFor: 'primitive algorithms - aux' stamp: 'jmv 7/14/2020 09:50:49'!
updateEdgesAndBoundsForX: x y: y

	| thisYTruncated pixelY pixelIndex increment count pixelX |

	blendLeft _ blendLeft min: x.
	blendTop _ blendTop min: y.
	blendRight _ blendRight max: x.
	blendBottom _ blendBottom max: y.

	"Compute edges intersecting with this horizontal line, for fills."
	fillColor notNil ifTrue: [
		thisYTruncated _ y truncated.
		(thisYTruncated between: clipTop-1 and: clipBottom) ifTrue: [
			prevYTruncated isNil
				ifTrue: [ prevYTruncated _ thisYTruncated ]
				ifFalse: [
					thisYTruncated = prevYTruncated ifFalse: [
						"All edge count at the left of the clipRect are added there (at the left of the clipRect).
						The effect is the same, and we need to clean up less stuff afterwards.
						More important, it avoids trying to acess pixels outside our form, i.e. invalid array acesses."
						pixelX _ x truncated + 1 max: clipLeft.
						pixelX <= clipRight ifTrue: [
							pixelY _ thisYTruncated max: prevYTruncated.
							increment _ (thisYTruncated - prevYTruncated) sign.
							pixelIndex _ pixelY * targetWidth + pixelX +1.
							count _ edgeCounts at: pixelIndex.
							count _ count + increment bitAnd: 16rFF.
							edgeCounts at: pixelIndex put: count ].
						prevYTruncated _ thisYTruncated.
						]]]].! !

